<?php
/**
 * ECSHOP 订单获取接口
 */

define('IN_ECS', true);

require('./init.php');
require_once(ROOT_PATH . 'includes/lib_order.php');
require_once('../includes/cls_json.php');

function array_iconv($in_charset,$out_charset,$arr)
{
  return eval('return '.iconv($in_charset,$out_charset,var_export($arr,true).';'));
}

/* 检查密码是否正确 */
$username = !empty($_REQUEST['username'])?$_REQUEST['username']:'';
$password = !empty($_REQUEST['password'])?$_REQUEST['password']:'';

if (!$username || !$password)
{
	exit(json_encode(array('code' => -1, 'desc' => 'param error')));
}

$sql="SELECT `ec_salt` FROM ". $ecs->table('admin_user') ."WHERE user_name = '" . mysql_real_escape_string($username) . "'";
$ec_salt =$db->getOne($sql);

if(!empty($ec_salt))
{
	 /* 检查密码是否正确 */
	 $sql = "SELECT user_id, user_name, password, last_login, action_list, last_login,suppliers_id,ec_salt".
		" FROM " . $ecs->table('admin_user') .
		" WHERE user_name = '" . mysql_real_escape_string($username) . "' AND password = '" . md5(md5($password).$ec_salt) . "'";
}
else
{
	 /* 检查密码是否正确 */
	 $sql = "SELECT user_id, user_name, password, last_login, action_list, last_login,suppliers_id,ec_salt".
		" FROM " . $ecs->table('admin_user') .
		" WHERE user_name = '" . mysql_real_escape_string($username) . "' AND password = '" . md5($password) . "'";
}

$row = $db->getRow($sql);
if ($row)
{
	// 检查是否为供货商的管理员 所属供货商是否有效
	if (!empty($row['suppliers_id']))
	{
		$supplier_is_check = suppliers_list_info(' is_check = 1 AND suppliers_id = ' . $row['suppliers_id']);
		if (empty($supplier_is_check))
		{
		   exit(json_encode(array('code' => -3, 'desc' => 'privilege error')));
		}
	}
}
else
{
	exit(json_encode(array('code' => -4, 'desc' => 'username pass error')));
}

$encoding = strtolower($_REQUEST['encoding']);

require_once(ROOT_PATH . 'includes/lib_order.php');
require_once(ROOT_PATH . 'includes/lib_goods.php');

if ($_REQUEST['act'] == 'sync')
{
	$shipping_name;
	if ($encoding == 'gbk')
	{
		$shipping_name = iconv('UTF-8', 'GBK', $_REQUEST['shipping_name']);
	}
	else
	{
		$shipping_name = $_REQUEST['shipping_name'];
	}
	
	$invoice_no = $_REQUEST['invoice_no'];
	$order_sn = $_REQUEST['order_sn'];
	$shipping_id;	
	
	$sql = "SELECT shipping_status, pay_status, pay_id from " . $GLOBALS['ecs']->table('order_info') . " where order_sn='" . mysql_real_escape_string($order_sn) . "' limit 1";
	$ret = $db->getRow($sql);
	
	$sql="SELECT pay_code from ". $GLOBALS['ecs']->table('payment')." where pay_id= ".$ret['pay_id'];
	$cod = $db->getRow($sql);
	
	if ($res === FALSE)
	{
		exit(json_encode(array ('code' => -1, 'error_msg'=>'internal error')));
	}
	
	// 只有未发货 而且 货到付款 或者 已付款 才可以进行进一步的操作
	if (!($ret['shipping_status'] == 0 && ($cod['pay_code'] == 'cod' || $ret['pay_status'] == 2)))
	{
		exit(json_encode(array('code' => -1, 'error_msg' => 'original status is not correct')));
	}
	
	// update order_info
	$sql = 'shipping_status=1, order_status = 5, shipping_time = ' . gmtime();
	if ($shipping_name)
	{
		$sql .= ",shipping_name='" . mysql_real_escape_string($shipping_name) . "'";
		$sql_shipping_id = " SELECT shipping_id FROM " . $ecs->table('shipping') . " WHERE shipping_name = '" . mysql_real_escape_string($shipping_name) . "'";
		$shipping_arr = $db->getRow($sql_shipping_id);
		$shipping_id = $shipping_arr['shipping_id'];

		if (!$shipping_id)
		{
			exit(json_encode(array ('code' => -1, 'error_msg'=>'incorrect shipping name error')));
		}

		$sql .= ",shipping_id=" . $shipping_id;
	}
	if ($invoice_no)
	{
		$sql .= ",invoice_no='" . mysql_real_escape_string($invoice_no) . "'";
	}
	
	$sql = "update " . $GLOBALS['ecs']->table('order_info') . " set " . $sql . " WHERE order_sn='" . mysql_real_escape_string($order_sn) . "'";

	$res = $db->query($sql);
	if (!$res)
	{
		exit(json_encode(array ('code' => -1, 'error_msg'=>'internal error')));
	}
	
	// insert data into delivery_order
	$sql = "SELECT oi.order_sn, oi.order_id, oi.invoice_no, oi.add_time, oi.shipping_id, oi.shipping_name, oi.user_id, oi.consignee, oi.address, oi.country, oi.province, oi.city, oi.district, " .
				"oi.sign_building, oi.email, oi.zipcode, oi.tel, oi.mobile, oi.best_time, oi.postscript, oi.how_oos, oi.insure_fee, oi.shipping_fee, oi.agency_id, IFNULL(suppliers_id, 0) AS suppliers_id " .
		   " FROM " . $ecs->table('goods') . " AS g " .
		   " LEFT JOIN " . $ecs->table('order_goods') . " AS og ON og.goods_id = g.goods_id " . 
		   " LEFT JOIN " . $ecs->table("order_info") . " AS oi on oi.order_id = og.order_id " .
		   " WHERE oi.order_sn='" . mysql_real_escape_string($order_sn) . "'";

	$delivery = $db->getRow($sql);
	if($delivery === FALSE)
	{
		exit(json_encode(array ('code' => -1, 'error_msg'=>'internal error')));
	}
	
	$delivery['update_time'] = gmtime();
	$delivery['action_user'] = $username;
	$delivery['delivery_sn'] = get_delivery_sn();
	$delivery['status'] = 0; //已发货
	
	if (FALSE === $db->autoExecute($ecs->table('delivery_order'), $delivery, 'INSERT', '', 'SILENT'))
	{
		exit(json_encode(array ('code' => -1, 'error_msg'=>'internal error')));
	}
	
	exit(json_encode(array ('code' => 1, 'desc'=>'success')));
	
}

if ($_REQUEST['act'] == 'logistics')
{	
	$where = 'WHERE 1';	
	
	$sql = "SELECT s.shipping_code,s.shipping_name FROM " . $ecs->table('shipping') . " AS s " . $where;
	
	$shipping['shipping'] = $db->getAll($sql);
	if($shipping['shipping'] === FALSE)
	{
		exit(json_encode(array ('code' => -1, 'desc'=>'internal error1')));
	}
	
	if ($encoding == 'gbk')
	{
		echo json_encode(array_iconv('GBK', 'UTF-8', $shipping));
	}
	else
	{
		echo json_encode($shipping);
	}
	exit;
}


if ($_REQUEST['act'] == 'detail')
{
	$order_sn = $_REQUEST['order_sn'];
	
	$sql = "SELECT o.order_id,o.order_sn,o.add_time,o.order_status,o.shipping_status,o.order_amount,o.money_paid,o.pay_status,o.pay_id,o.pay_time," .
				"r1.region_name province,r2.region_name city,r3.region_name district,o.consignee,o.address,o.email,o.tel,o.mobile,o.zipcode," .
				"(" . order_amount_field('o.') . ") AS total_fee,o.shipping_fee,o.discount,o.postscript, " .
				"IFNULL(u.user_name, '" .$GLOBALS['_LANG']['anonymous']. "') AS buyer ".
			" FROM " . $ecs->table('order_info') . " AS o " .
			" LEFT JOIN " . $ecs->table('users') . " AS u ON u.user_id=o.user_id " . 
			" LEFT JOIN " . $ecs->table("region") . " AS r1 on r1.region_id=o.province " .
			" LEFT JOIN " . $ecs->table("region") . " AS r2 on r2.region_id=o.city " .
			" LEFT JOIN " . $ecs->table("region") . " AS r3 on r3.region_id=o.district " .
			" WHERE o.order_sn='" . mysql_real_escape_string($order_sn) . "'";
	
	$trade = $db->getRow($sql);
	if($trade === FALSE)
	{
		exit(json_encode(array ('code' => -1, 'desc'=>'internal error')));
	}
	
	$order_id = intval($trade['order_id']);
	
	$sql = "SELECT o.rec_id oid,o.goods_id,o.goods_name,o.goods_sn,o.goods_number,o.goods_price,o.goods_attr,o.is_real,p.product_id,p.product_sn
				FROM " . $ecs->table('order_goods') . " AS o
					LEFT JOIN " . $ecs->table('products') . " AS p
						ON p.product_id = o.product_id
				WHERE o.order_id = '{$order_id}'";
	
	$trade['goods_list'] = $db->getAll($sql);
	if($trade['goods_list'] === FALSE)
	{
		exit(json_encode(array ('code' => -1, 'desc'=>'internal error')));
	}
	
	if ($encoding == 'gbk')
	{
		echo json_encode(array_iconv('GBK', 'UTF-8', $trade));
	}
	else
	{
		echo json_encode($trade);
	}
	
	exit;
}

if ($_REQUEST['act'] == 'list')
{
	$page_no = (int)$_REQUEST['page'];
	$page_size = (int)$_REQUEST['pagesize'];
	if($page_size > 20) $page_size = 20;
	if($page_no < 1) $page_no = 1;
	
	$where = 'WHERE 1';
	
	if(!empty($_REQUEST['start_time']))
		$where .= " AND o.add_time>='" . local_strtotime($_REQUEST['start_time']) . "'";
	
	if(!empty($_REQUEST['end_time']))
		$where .= " AND o.add_time<='" . local_strtotime($_REQUEST['end_time']) . "'";
	
	//订单条数
	$sql = "SELECT COUNT(*) FROM " . $ecs->table('order_info') . " AS o " . $where;
	$trades['total'] = $db->getOne($sql);
	
	//订单列表 加入了表payment中的pay_code支付方式代码
	$sql = "SELECT o.order_id,o.order_sn,o.add_time,o.order_status,o.shipping_status,o.order_amount,o.money_paid,o.pay_status,o.pay_id,o.pay_time,o.inv_payee,o.inv_content,o.inv_type," .
				"r1.region_name province,r2.region_name city,r3.region_name district,p.pay_code,o.consignee,o.address,o.email,o.tel,o.mobile,o.zipcode,o.shipping_name," .
				"(" . order_amount_field('o.') . ") AS total_fee,o.shipping_fee,o.discount,o.postscript, " .
				"IFNULL(u.user_name, '" .$GLOBALS['_LANG']['anonymous']. "') AS buyer ".
			" FROM " . $ecs->table('order_info') . " AS o " .
			" LEFT JOIN " . $ecs->table('users') . " AS u ON u.user_id=o.user_id " . 
			" LEFT JOIN " . $ecs->table("region") . " AS r1 on r1.region_id=o.province " .
			" LEFT JOIN " . $ecs->table("region") . " AS r2 on r2.region_id=o.city " .
			" LEFT JOIN " . $ecs->table("region") . " AS r3 on r3.region_id=o.district " .
			" LEFT JOIN " . $ecs->table("payment") . " AS p on p.pay_id=o.pay_id " .
			$where .
			" ORDER BY add_time DESC ".
			" LIMIT " . (($page_no - 1) * $page_size) . ",{$page_size}";
	
	$trades['orders'] = $db->getAll($sql);
	if($trades['orders'] === FALSE)
	{
		exit(json_encode(array ('code' => -1, 'desc'=>'internal error1')));
	}
	
	/* 取得订单商品及货品 */
	foreach ($trades['orders'] as &$trade)
	{
		$order_id = intval($trade['order_id']);
		
		$sql = "SELECT o.rec_id oid,o.goods_id,o.goods_name,o.goods_sn,o.goods_number,o.goods_price,o.goods_attr,o.is_real,p.product_id,p.product_sn
				FROM " . $ecs->table('order_goods') . " AS o
					LEFT JOIN " . $ecs->table('products') . " AS p
						ON p.product_id = o.product_id
				WHERE o.order_id = '{$order_id}'";
		
		$trade['goods_list'] = $db->getAll($sql);
		
		if($trade['goods_list'] === FALSE)
		{
			exit(json_encode(array ('code' => -1, 'desc'=>'internal error2')));
		}
	}
	
	if ($encoding == 'gbk')
	{
		echo json_encode(array_iconv('GBK', 'UTF-8', $trades));
	}
	else
	{
		echo json_encode($trades);
	}
	exit;
}

if ($_REQUEST['act'] == 'sync_stock')
{
	$goods_id = (int)$_REQUEST['goods_id'];
	$product_id = (int)$_REQUEST['product_id'];
	$stock_count = (int)$_REQUEST['stock_count'];
	
	if ($product_id)
	{
		$sql = "UPDATE " . $GLOBALS['ecs']->table('products') . " SET product_number = " . $stock_count . " WHERE product_id = " . $product_id;

		$res = $db->query($sql);
		if (!$res)
		{
			exit(json_encode(array ('code' => -1, 'error_msg'=>'internal error')));
		}

		$sql = "UPDATE " . $GLOBALS['ecs']->table('goods') . " SET goods_number = ( SELECT SUM(product_number) FROM " . $GLOBALS['ecs']->table('products') . " WHERE goods_id = " . $goods_id . ") WHERE goods_id = " . $goods_id;

		$res = $db->query($sql);
		if (!$res)
		{
			exit(json_encode(array ('code' => -1, 'error_msg'=>'internal error')));
		}
	}
	else
	{
		$sql = "UPDATE " . $GLOBALS['ecs']->table('goods') . " SET goods_number = " . $stock_count . " WHERE goods_id = " . $goods_id;

		$res = $db->query($sql);
		if (!$res)
		{
			exit(json_encode(array ('code' => -1, 'error_msg'=>'internal error')));
		}
	}
	
	exit(json_encode(array ('code' => 1, 'desc'=>'success')));
}

if ($_REQUEST['act'] == 'get_goods')
{
	$page_no = (int)$_REQUEST['page'];
	$page_size = (int)$_REQUEST['pagesize'];
	if($page_size > 20) $page_size = 20;
	if($page_no < 1) $page_no = 1;
	
	$where = 'WHERE g.is_delete = 0 ';
	
	if(!empty($_REQUEST['start_time']))
		$where .= " AND g.add_time>='" . local_strtotime($_REQUEST['start_time']) . "'";
	
	if(!empty($_REQUEST['end_time']))
		$where .= " AND g.add_time<='" . local_strtotime($_REQUEST['end_time']) . "'";
		
	if(isset($_REQUEST['is_on_sale']))
		$where .= " AND g.is_on_sale = " . $_REQUEST['is_on_sale'];
		
	if(isset($_REQUEST['goods_name']))
		$where .= " AND g.goods_name like '%" . $_REQUEST['goods_name'] . "%'";
	
	//get goods count
	$sql = "SELECT COUNT(*) FROM " . $ecs->table('goods') . " AS g " . $where;
	$all_goods['total'] = $db->getOne($sql);
	
	//get goods list
	$sql = "SELECT g.goods_id,g.shop_price ,g.goods_name ,g.goods_number ,g.goods_sn,g.goods_img,g.is_on_sale ,COUNT(*) as total_spec " .
			" FROM " . $ecs->table('goods') . " AS g " .
			$where .
			" GROUP BY g.goods_id ".
			" ORDER BY g.add_time DESC ".
			" LIMIT " . (($page_no - 1) * $page_size) . ",{$page_size}";

	$all_goods['goods'] = $db->getAll($sql);
	if($all_goods['goods'] === FALSE)
	{
		exit(json_encode(array ('code' => -1, 'desc'=>'internal error1')));
	}
	
	// get spec list
	foreach ($all_goods['goods'] as &$goods)
	{
		$goods_id = intval($goods['goods_id']);
		
		$sql = "SELECT p.product_id ,p.product_sn,p.goods_attr,p.product_number ".
			   " FROM " . $ecs->table('products') . " AS p ".
			   " WHERE p.goods_id = {$goods_id} ";
		
		$goods['spec'] = $db->getAll($sql);
		
		if($goods['spec'] === FALSE)
		{
			exit(json_encode(array ('code' => -1, 'desc'=>'internal error2')));
		}
		
		foreach ($goods['spec'] as &$product)
		{
			// goods_attr in product table is glued by '|' in admin/goods.php line 2433
			$ids = str_replace('|', ',', $product['goods_attr']);
			/*
			$arr = explode('|', $product['goods_attr']);

			$ids = '';
			foreach ($arr as $id)
			{
				$ids .= $id . ',';
			}
			$ids = substr($ids, 0, strlen($ids) - 1);
			*/
			$sql = "SELECT ga.attr_price, ga.attr_value ".
				   " FROM " . $ecs->table('goods_attr') . " AS ga ".
				   " WHERE ga.goods_id = {$goods_id} and ga.goods_attr_id in ($ids) ";

			$attrs = $db->getAll($sql);

			if($attrs === FALSE)
			{
				exit(json_encode(array ('code' => -1, 'desc'=>'internal error3')));
			}
			
			foreach ($attrs as $attr)
			{
				$product['attr_price'] += $attr['attr_price'];
				$product['attr_value'] .= $attr['attr_value'] . ' ';
			}
			
			$product['attr_value'] = trim($product['attr_value']);
			
		}
	}
	
	if ($encoding == 'gbk')
	{
		echo json_encode(array_iconv('GBK', 'UTF-8', $all_goods));
	}
	else
	{
		echo json_encode($all_goods);
	}
	exit;
}
if ($_REQUEST['act'] == 'get_OrderByNo')
{
	$orderNo = $_REQUEST['orderNo'];	
	$where = 'WHERE 1';
	$where.=" AND o.order_sn='". $orderNo ."'";		
	//订单条数
	$sql = "SELECT COUNT(*) FROM " . $ecs->table('order_info') . " AS o " . $where;
	$trades['total'] = $db->getOne($sql);
	
	//订单列表 加入了表payment中的pay_code支付方式代码
	$sql = "SELECT o.order_id,o.order_sn,o.add_time,o.order_status,o.shipping_status,o.order_amount,o.money_paid,o.pay_status,o.pay_id,o.pay_time,o.inv_payee,o.inv_content,o.inv_type," .
				"r1.region_name province,r2.region_name city,r3.region_name district,p.pay_code,o.consignee,o.address,o.email,o.tel,o.mobile,o.zipcode,o.shipping_name," .
				"(" . order_amount_field('o.') . ") AS total_fee,o.shipping_fee,o.discount,o.postscript, " .
				"IFNULL(u.user_name, '" .$GLOBALS['_LANG']['anonymous']. "') AS buyer ".
			" FROM " . $ecs->table('order_info') . " AS o " .
			" LEFT JOIN " . $ecs->table('users') . " AS u ON u.user_id=o.user_id " . 
			" LEFT JOIN " . $ecs->table("region") . " AS r1 on r1.region_id=o.province " .
			" LEFT JOIN " . $ecs->table("region") . " AS r2 on r2.region_id=o.city " .
			" LEFT JOIN " . $ecs->table("region") . " AS r3 on r3.region_id=o.district " .
			" LEFT JOIN " . $ecs->table("payment") . " AS p on p.pay_id=o.pay_id " .
			$where .
			" ORDER BY add_time DESC ";
	
	$trades['orders'] = $db->getAll($sql);
	if($trades['orders'] === FALSE)
	{
		exit(json_encode(array ('code' => -1, 'desc'=>'internal error1')));
	}
	
	/* 取得订单商品及货品 */
	foreach ($trades['orders'] as &$trade)
	{
		$order_id = intval($trade['order_id']);
		
		$sql = "SELECT o.rec_id oid,o.goods_id,o.goods_name,o.goods_sn,o.goods_number,o.goods_price,o.goods_attr,o.is_real,p.product_id,p.product_sn
				FROM " . $ecs->table('order_goods') . " AS o
					LEFT JOIN " . $ecs->table('products') . " AS p
						ON p.product_id = o.product_id
				WHERE o.order_id = '{$order_id}'";
		
		$trade['goods_list'] = $db->getAll($sql);
		
		if($trade['goods_list'] === FALSE)
		{
			exit(json_encode(array ('code' => -1, 'desc'=>'internal error2')));
		}
	}
	
	if ($encoding == 'gbk')
	{
		echo json_encode(array_iconv('GBK', 'UTF-8', $trades));
	}
	else
	{
		echo json_encode($trades);
	}
	exit;
}
?>